<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: Main Page</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Eddie Documentation</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p><a class="anchor" id="md__builds_eclipse_oniro_core_eddie_README"></a></p>
<h1><a class="anchor" id="autotoc_md12"></a>
EDDIE Project</h1>
<p>Welcome to the EDDIE, part of the Oniro* Project, main git repository! Oniro is an Eclipse Foundation project focused on the development of a distributed open source operating system for consumer devices.</p>
<p>**Oniro is a trademark of Eclipse Foundation.*</p>
<h1><a class="anchor" id="autotoc_md13"></a>
About</h1>
<p>The <b>EDDIE</b> repository is home of a middleware in the Oniro Project to enable distributed intelligence on Oniro devices.</p>
<p>The objective of the EDDIE project is to design a middleware running on top of the operating system of the various Oniro devices. Capable of giving to the applications and services an global view on a unified pool of virtual resources that can be exploited for an efficient execution of any application or service required by the user.</p>
<h2><a class="anchor" id="autotoc_md14"></a>
Contributing</h2>
<p>See the <code>CONTRIBUTING.md</code> file.</p>
<h2><a class="anchor" id="autotoc_md15"></a>
License</h2>
<p>See the <code>LICENSES</code> subdirectory.</p>
<h2><a class="anchor" id="autotoc_md16"></a>
Security</h2>
<p>See the <code>SECURITY.md</code> file.</p>
<h2><a class="anchor" id="autotoc_md17"></a>
EDDIE structure</h2>
<p>The structure of the EDDIE project is vertically divided into layers and this division reflects the structure of the EDDIE repository.</p>
<p>While the communication and the virtualization layer are detailed below and already present in the EDDIE repository, an intelligent layer is planned, to enable reasoning and smart resource distribution across the EDDIE network. Currently, there is only a mocked version of this layer.</p>
<p>Lastly an application management layer is also planned, providing advanced functionalities for process management in both local and remote EDDIE nodes.</p>
<h3><a class="anchor" id="autotoc_md18"></a>
Layers</h3>
<p>In the following paragraphs there is a more detailed description of the layers of EDDIE.</p>
<ul>
<li><b>Communication Layer</b></li>
</ul>
<p>The bottommost component of EDDIE is the communication layer: it is responsible for all the networking bits of EDDIE, from the creation and setup of the connection to the message dispatching to other nodes.</p>
<p>Every device that runs EDDIE has a server component, application logic that describes what capabilities (resources) that device has and answers to requests from other nodes. <br  />
 Alongside the server element, a EDDIE device is equipped with a client component, allowing the device to comunicate actively in the network, performing requests to other devices.</p>
<p>Additionally, one node in the EDDIE network is elected as Resource Directory (RD): a new EDDIE node that wants to connect to the network should post its resources description in the RD, while from the RD it can retreive the descriptions of other nodes.</p>
<p>The communication layer exposes a list of APIs to the higher layers of EDDIE, allowing complex actions and queries to be executed in the EDDIE network.</p>
<ul>
<li><b>Virtualization layer</b></li>
</ul>
<p>The Virtualization layer is responsible for the interaction between the EDDIE network (through the communication layer) and the single EDDIE-enabled application running on the device.</p>
<p>This layer is composed of two elements that are communicating through the IPC mechanism of d-bus:</p><ul>
<li>a receiver component that exposes its API on d-bus, allowing multiple applications to interact with EDDIE at the same time. The API is composed of a single function <code>PerformAction</code> that models the action that the application wants to execute on the network, like changing or getting the status of a resource.</li>
<li>a sender component is also present in the virtualization directory with the role of transmitting the requests generated by EDDIE-enabled application to the EDDIE service on the device.</li>
</ul>
<h3><a class="anchor" id="autotoc_md19"></a>
Examples</h3>
<p>Examples on how to use the EDDIE APIs can be found in <code>/linux/examples</code>.</p>
<p>For more details, take a look at the <a href="https://docs.svc.ostc-eu.dev/">doxygen API documentations</a>.</p>
<h2><a class="anchor" id="autotoc_md20"></a>
Linux build instructions</h2>
<h3><a class="anchor" id="autotoc_md21"></a>
Prerequisites</h3>
<p>The following part of the document details how to install and configure all packages and libraries required to have a working copy of EDDIE.</p>
<h4><a class="anchor" id="autotoc_md22"></a>
libcoap</h4>
<p>libcoap is a C implementation of the application-level protocol CoAP. <br  />
 The version of libcoap currently used by EDDIE is <code>version 4.3.0</code>.</p>
<p>If libcoap is already installed in your system you can skip the following installation procedure.</p>
<p>libcoap itself requires some packages to correctly complete its installation procedure: they can be installed with the following commands:</p>
<div class="fragment"><div class="line">$ (sudo) apt-get install autoconf -y</div>
<div class="line">$ (sudo) apt-get install libtool -y</div>
</div><!-- fragment --><p>Then launch these commands to install libcoap in your machine:</p>
<div class="fragment"><div class="line">$ git clone https://github.com/obgm/libcoap.git</div>
<div class="line">$ git checkout release-4.3.0</div>
<div class="line">$ cd libcoap</div>
<div class="line">$ ./configure --disable-documentation --disable-dtls</div>
<div class="line">$ make</div>
<div class="line">$ (sudo) make install</div>
<div class="line">$ (sudo) ldconfig</div>
</div><!-- fragment --><p> For further details on libcoap have a look at the <a href="https://github.com/obgm/libcoap">github repository</a> and at the <a href="https://libcoap.net/">official libcoap documentation page</a>.</p>
<h4><a class="anchor" id="autotoc_md23"></a>
Glib</h4>
<p>Installation instructions for Glib and its requirements can be found at the <a href="https://github.com/GNOME/glib/blob/main/INSTALL.md?plain=1">Glib installation page</a>.</p>
<h3><a class="anchor" id="autotoc_md24"></a>
Build</h3>
<ul>
<li>If you want to run EDDIE on your local machine build the CMake project:</li>
</ul>
<div class="fragment"><div class="line">$ mkdir build &amp;&amp; cd build</div>
<div class="line">$ cmake ..</div>
<div class="line">$ make</div>
</div><!-- fragment --><ul>
<li>Then you can find some binaries in the <code>build/linux/</code> subdirectory:<ul>
<li><code>eddie-endpoint</code> is used to test the EDDIE communication layer by initializing an <a href="https://docs.svc.ostc-eu.dev/classEddieEndpoint.html">EddieEndpoint</a> for the CoAP communication and resource registration and discovery. In this executable a resource directory discovery request is sent and if a one is not found, a new resource directory is initialized. If <code>--example-res</code> flag is set, the node will publish some example resources, and finally, the node will retrieve the available resources in the resource directory. Run <code>eddie-endpoint --help</code> for more information.</li>
<li><code>eddie-virt-server</code> runs a <code>VirtualizationReceiver</code> which starts a DBus server and initializes an <a href="https://docs.svc.ostc-eu.dev/classEddieEndpoint.html">EddieEndpoint</a>.</li>
<li><code>eddie-virt-client</code> is an example of application side code that, using <code>VirtualizationSender</code>, runs a DBus client to communicate with the virtualization server side.</li>
</ul>
</li>
<li>If you want to build the Oniro Blueprint for the EDDIE project, and run on an Oniro supported target: follow the instructions in the <a href="https://gitlab.eclipse.org/eclipse/oniro-blueprints/meta-oniro-blueprints-eddie.git">EDDIE blueprint git repository</a>.</li>
</ul>
<h2><a class="anchor" id="autotoc_md25"></a>
Zephyr build instructions</h2>
<h3><a class="anchor" id="autotoc_md26"></a>
Description</h3>
<p>A device node provides its resources by means of CoAP resources. The Zephyr node will publish its resources into the resource directory on linux using CoAP protocol. After publishing the resource, the Zephyr node will run a CoAP server providing an endpoint specified by the published resource.</p>
<p>We tested both the resource publish and the CoAP server endpoint, in the following setups:</p><ul>
<li>Two QEMU instances with bridged networking, one QEMU running EDDIE on Zephyr and the other running an EDDIE endpoint on Oniro Linux</li>
<li>An EDDIE Zephyr node on the Arduino Nano 33 BLE board connected via OpenThread to a Raspberry Pi OpenThread border router that runs an EDDIE endpoint.</li>
</ul>
<h3><a class="anchor" id="autotoc_md27"></a>
Run on QEMU</h3>
<p>If you want to have QEMU with networking, create one tap device for each QEMU instance (you can use a script provided in oe-core): </p><div class="fragment"><div class="line">$ sudo oe-core/scripts/runQEMU-gen-tapdevs 1000 1000 2 tmp/sysroots-components/x86_64/QEMU-helper-native/usr/bin</div>
</div><!-- fragment --><p> Bridge tap devices so the QEMU instances can communicate with each other </p><div class="fragment"><div class="line">$ sudo ip link add br0 type bridge</div>
<div class="line">$ sudo ip link set br0 up</div>
<div class="line">$ sudo ip addr add 2001:db8:0:1::100/64 dev br0</div>
<div class="line">$ sudo ip link set tap0 master br0</div>
<div class="line">$ sudo ip link set tap1 master br0</div>
</div><!-- fragment --><p> Assuming the linux node with EDDIE service is running on tap0 network interface, use the following command to run the Zephyr node on QEMU using the tap1 interface.</p>
<div class="fragment"><div class="line">$ west build -b QEMU_x86 -t run --pristine  --    -DOVERLAY_CONFIG=overlay-e1000.conf  -DCONFIG_NET_CONFIG_MY_IPV6_ADDR=\&quot;2001:db8:0:1::1\&quot; -DCONFIG_ETH_QEMU_IFACE_NAME=\&quot;tap1\&quot;    -DCONFIG_ETH_QEMU_EXTRA_ARGS=\&quot;mac=00:00:5e:00:53:01\&quot;</div>
</div><!-- fragment --><h3><a class="anchor" id="autotoc_md28"></a>
Run on Arduino Nano 33 BLE</h3>
<ul>
<li>Build with the OpenThread overlay <div class="fragment"><div class="line">$ west build -b arduino_nano_33_ble --  -DOVERLAY_CONFIG=overlay-openthread.conf</div>
</div><!-- fragment --></li>
<li>Flash the image into your arduino board <a href="https://docs.Zephyrproject.org/2.7.0/boards/arm/arduino_nano_33_ble/doc/index.html">using bossac</a></li>
<li>Run the EDDIE Linux node on the Raspberry Pi board following the <a href="https://gitlab.eclipse.org/eclipse/oniro-blueprints/meta-oniro-blueprints-eddie.git">EDDIE blueprint instructions</a>.</li>
<li>Follow the <a href="https://docs.oniroproject.org/projects/blueprints/transparent-gateway.html">transparent gateway documentation</a> to connect the Arduino board to the Raspberry Pi via OpenThread.</li>
</ul>
<p>The Zephyr node will be able to publish its resources to the Linux node. </p>
</div></div><!-- PageDoc -->
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
